# The NixOS Installer

This installer is named after my doggo Onyxia.

At the core of this installer it does the following:

- Partition the drive of your choice using the `rsfdisk` crate.
- Uses `flake.nix` to set certain modules depending on the system like nixos-hardware for the Pinebook Pro
- Installs a base of NixOS (`configuration.nix`)

nix files are from [this repo](https://gitlab.com/ahoneybun/nix-configs/) but that can be changed as needed.

This sets the hashedPassword to my own so you will need to update it to match your own as well as the username. I created the hash with this command:

```bash
mkpasswd -m sha-512
```

# Development

## Clone the repository

```bash
git clone https://gitlab.com/ahoneybun/nyxi-installer.git
```

## Enter the repository that you just cloned

```bash
cd nyxi-installer
```

## Enter nix-shell

This is if you are already running NixOS on your system where development will take place. This will install the needed system packages, set environment variables and such for development.

```bash
nix-shell
```

## Building and testing

You can use normal `cargo` commands like:

- `cargo test`
- `cargo build`
- `cargo run`

**NOTE:** you will need to build the program and run it with `sudo` currently so `cargo run` is not the best for testing.
